local totalG = 0;
local totalW = 0;
local totalD = 0;
local sub = {};

function handle_record(record)
    local amt = record:get('Amount') + 0;
    totalG = totalG + amt;
    local i = record:get('CATEGID');
    if sub[i] == nil then
       sub[i]=0;
    end
    sub[i] = sub[i] + amt;

    if  (amt > 0) then
        totalD = totalD + amt
    else
        totalW = totalW + amt
    end
end

function complete(result)
    result:set("Inc", totalD);
    result:set("Exp", totalW);
    result:set("Tot", totalG);

    local subtotals = '';
    for k,v in pairs(sub) do
        subtotals = subtotals .. k .. ":" .. sub[k] .. ",";
    end

    result:set("Subtotals", string.format("[{%s}]" , subtotals));
end